/*
  Software serial multple serial test
 
 Receives from the hardware serial, sends to software serial.
 Receives from software serial, sends to hardware serial.
 
 The circuit: 
 * RX is digital pin 10 (connect to TX of other device)
 * TX is digital pin 11 (connect to RX of other device)
 
 Note:
 Not all pins on the Mega and Mega 2560 support change interrupts, 
 so only the following can be used for RX: 
 10, 11, 12, 13, 50, 51, 52, 53, 62, 63, 64, 65, 66, 67, 68, 69
 
 Not all pins on the Leonardo support change interrupts, 
 so only the following can be used for RX: 
 8, 9, 10, 11, 14 (MISO), 15 (SCK), 16 (MOSI).
 
 created back in the mists of time
 modified 25 May 2012
 by Tom Igoe
 based on Mikal Hart's example
 
 This example code is in the public domain.
 
 */
#include <SoftwareSerial.h>
SoftwareSerial mySerial(10, 11); // RX, TX

char inData[20]; // Allocate some space for the string
char inChar=-1; // Where to store the character read
byte index = 0; // Index into array; where to store the character

void setup()  
{
  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for Leonardo only
  }

  pinMode(2, OUTPUT); 
  pinMode(3, OUTPUT); 
  Serial.println("Goodnight moon!");
  mySerial.begin(9600);
  mySerial.print("Hello, world?");
}


char Comp(char* This) {
    while (mySerial.available() > 0) // Don't read unless
                                   // there you know there is data
    {
        if(index < 19) // One less than the size of the array
        {
            inChar = mySerial.read(); // Read a character
            inData[index] = inChar; // Store it
            index++; // Increment where to write next
            inData[index] = '\0'; // Null terminate the string
            Serial.write(inChar);
        }
    }

    if (strcmp(inData,This)  == 0) {
        for (int i=0;i<19;i++) {
            inData[i]=0;
        }
        index=0;
        return(0);
    }
    else {
        return(1);
    }
}

void loop()
{
    if (Comp("m2 on\n")==0) {
        digitalWrite(2, HIGH); 
        Serial.write("pin 2 -> on\n");
    }
    if (Comp("m2 off\n")==0) {
        digitalWrite(2, LOW); 
        Serial.write("pin 2 -> off\n");
    } 
    if (Comp("m3 on\n")==0) {
        digitalWrite(3, HIGH); 
        Serial.write("pin 3 -> on\n");
    }
    if (Comp("m3 off\n")==0) {
        digitalWrite(3, LOW); 
        Serial.write("pin 3 -> off\n");
    }
    if (Comp("m4 on\n")==0) {
        digitalWrite(4, HIGH); 
        Serial.write("pin 4 -> on\n");
    }
    if (Comp("m4 off\n")==0) {
        digitalWrite(4, LOW); 
        Serial.write("pin 4 -> off\n");
    }
    if (Comp("m5 on\n")==0) {
        digitalWrite(5, HIGH); 
        Serial.write("pin 5 -> on\n");
    }
    if (Comp("m5 off\n")==0) {
        digitalWrite(5, LOW); 
        Serial.write("pin 5 -> off\n");
    }
    if (Comp("m6 on\n")==0) {
        digitalWrite(6, HIGH); 
        Serial.write("pin 6 -> on\n");
    }
    if (Comp("m6 off\n")==0) {
        digitalWrite(6, LOW); 
        Serial.write("pin 6 -> off\n");
    }
    if (Comp("m7 on\n")==0) {
        digitalWrite(7, HIGH); 
        Serial.write("pin 7 -> on\n");
    }
    if (Comp("m7 off\n")==0) {
        digitalWrite(7, LOW); 
        Serial.write("pin 7 -> off\n");
    }
    if (Comp("m8 on\n")==0) {
        digitalWrite(8, HIGH); 
        Serial.write("pin 8 -> on\n");
    }
    if (Comp("m8 off\n")==0) {
        digitalWrite(8, LOW); 
        Serial.write("pin 8 -> off\n");
    }
    if (Comp("m9 on\n")==0) {
        digitalWrite(9, HIGH); 
        Serial.write("pin 9 -> on\n");
    }
    if (Comp("m9 off\n")==0) {
        digitalWrite(9, LOW); 
        Serial.write("pin 9 -> off\n");
    }

}

